/* hello.c
   
   Sample code demonstrates use of on board LCD, sprintf(),and 10ms tick
   generation using timer0 interrupt.
   code size: approx. 3141 bytes

   Copyright (C) 2004 WICHIT SIRICHOTE, kswichit@kmitl.ac.th

*/

#include <stdio.h>
#include <reg52.h>
#include <math.h>   

float n1=125.02109;

char i=0;
char tick;

// functions prototype declarartion
InitLcd(void);
char *Puts(char* str);
goto_xy(char x,char y);
void putch_lcd(char ch);

// timer interrupt service routine

void timer0int (void)  interrupt 1  using 1  {
	TH0 |= 0xdc;  // reload timer 0 with 0DC00H with 11.0592MHz
	tick++;
	          
}

void main()
{

   char buffer[16];
   EA = 1;
   ET0 = 1;  // or IE |= 0x82;   /* set bit EA and Timer0 enable */ 
   TMOD |= 0x01; /* timer 0 run 16 bit counter */
   TR0 = 1; //or TCON |= 0x10; /* run timer 0 */
   InitLcd();
   putch_lcd(0xe4); 
   Puts("Vision c51 test");
   
   while(1)
    	{
  	while(tick<10) // until 100ms 
  	;
        tick = 0;
  	P1 ^= 0x80;  // toggle P1.7
       	sprintf(buffer,"%f ms",sqrt(n1)); 
        printf("\n%s",buffer); // print on terminal
	goto_xy(0,1); // select 2nd line
	Puts(buffer); // write to lcd
	n1+=2.00001;
	
  	}
}


