// below addresses are lcd's registers mapped to external data memory space
// see the schematic of 8051sbc for memory mapped i/o

#define BUSY 0x80  // busy flag location

#define LCD_command_write (*((unsigned char xdata*)0x0000))
#define LCD_data_write (*((unsigned char xdata*)0x0001))
#define LCD_command_read (*((unsigned char xdata*)0x0002))
#define LCD_data_read (*((unsigned char xdata*)0x0003))

#define LCD 0x0A

goto_xy(char x,char y);

char LcdReady(void)
{
	unsigned char flag;
      	while( (flag=LCD_command_read)&BUSY)  
	{
		if(flag == 0xFF) return -1;  
	}
      	return 1;
}


void clr_screen(void)       
{
	LcdReady();
        LCD_command_write=0x01;
}


char InitLcd(void)
{
	if(-1 ==LcdReady()) return -1;
        LCD_command_write=0x38;

	LcdReady();
        LCD_command_write=0x0c;
        clr_screen();
        goto_xy(0,0);
}

goto_xy(char x,char y)
{
    LcdReady();
    switch(y){
        case 0 : LCD_command_write=0x80+x; break;
        case 1 : LCD_command_write=0xC0+x; break;
        case 2 : LCD_command_write=0x94+x; break;
        case 3 : LCD_command_write=0xd4+x; break;
    }
}

char *Puts(char* str)
{
	unsigned char i;

	for (i=0; str[i] != '\0'; i++){
		LcdReady();
                LCD_data_write=str[i];
	}
	return str;
}


void putch_lcd(char ch)
{
	LcdReady();
        LCD_data_write=ch;
}












